# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`puppet_certificate`](#puppet_certificate): Manage Puppet certificates

## Resource types

### <a name="puppet_certificate"></a>`puppet_certificate`

Manage Puppet certificates

#### Properties

The following properties are available in the `puppet_certificate` type.

##### `dns_alt_names`

Alternate DNS names by which the certificate holder may be reached

##### `ensure`

Valid values: `present`, `absent`, `valid`

Create or remove the Puppet certificate

Default value: `present`

#### Parameters

The following parameters are available in the `puppet_certificate` type.

* [`ca_location`](#-puppet_certificate--ca_location)
* [`ca_server`](#-puppet_certificate--ca_server)
* [`clean`](#-puppet_certificate--clean)
* [`name`](#-puppet_certificate--name)
* [`onrefresh`](#-puppet_certificate--onrefresh)
* [`provider`](#-puppet_certificate--provider)
* [`renewal_grace_period`](#-puppet_certificate--renewal_grace_period)
* [`waitforcert`](#-puppet_certificate--waitforcert)

##### <a name="-puppet_certificate--ca_location"></a>`ca_location`

Valid values: `local`, `remote`

The location of the certificate authority (local or remote)

Default value: `remote`

##### <a name="-puppet_certificate--ca_server"></a>`ca_server`

The certificate authority to use

##### <a name="-puppet_certificate--clean"></a>`clean`

Valid values: `true`, `false`

Delete the certificate from the CA before removing it locally.

Default value: `false`

##### <a name="-puppet_certificate--name"></a>`name`

namevar

The certificate name

##### <a name="-puppet_certificate--onrefresh"></a>`onrefresh`

Valid values: `regenerate`, `nothing`

If set to 'regenerate', a refresh event will cause the certificate to be destroyed and recreated.

Default value: `nothing`

##### <a name="-puppet_certificate--provider"></a>`provider`

The specific backend to use for this `puppet_certificate` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

##### <a name="-puppet_certificate--renewal_grace_period"></a>`renewal_grace_period`

The number of days before expiration the certificate should be renewed

Default value: `0`

##### <a name="-puppet_certificate--waitforcert"></a>`waitforcert`

The amount of time to wait for the certificate to be signed

